diff --git a/libavcodec/Makefile b/libavcodec/Makefile
index cd929da8e6..8554b5ee7d 100644
--- a/libavcodec/Makefile
+++ b/libavcodec/Makefile
@@ -542,6 +542,8 @@ OBJS-$(CONFIG_MXPEG_DECODER)           += mxpegdec.o
 OBJS-$(CONFIG_NELLYMOSER_DECODER)      += nellymoserdec.o nellymoser.o
 OBJS-$(CONFIG_NELLYMOSER_ENCODER)      += nellymoserenc.o nellymoser.o
 OBJS-$(CONFIG_NOTCHLC_DECODER)         += notchlc.o
+OBJS-$(CONFIG_NULL_AUDIO_ENCODER)      += nullenc.o
+OBJS-$(CONFIG_NULL_VIDEO_ENCODER)      += nullenc.o
 OBJS-$(CONFIG_NUV_DECODER)             += nuv.o rtjpeg.o
 OBJS-$(CONFIG_ON2AVC_DECODER)          += on2avc.o on2avcdata.o
 OBJS-$(CONFIG_OPUS_DECODER)            += opusdec.o opus.o opus_celt.o opus_rc.o \
diff --git a/libavcodec/allcodecs.c b/libavcodec/allcodecs.c
index 628d27fd75..a30920bfe2 100644
--- a/libavcodec/allcodecs.c
+++ b/libavcodec/allcodecs.c
@@ -487,6 +487,8 @@ extern const AVCodec ff_mpc8_decoder;
 extern const AVCodec ff_msnsiren_decoder;
 extern const AVCodec ff_nellymoser_encoder;
 extern const AVCodec ff_nellymoser_decoder;
+extern const AVCodec ff_null_audio_encoder;
+extern const AVCodec ff_null_video_encoder;
 extern const AVCodec ff_on2avc_decoder;
 extern const AVCodec ff_opus_encoder;
 extern const AVCodec ff_opus_decoder;
diff --git a/libavcodec/codec_desc.c b/libavcodec/codec_desc.c
index 81f3b3c640..7d6bfd352c 100644
--- a/libavcodec/codec_desc.c
+++ b/libavcodec/codec_desc.c
@@ -3516,6 +3516,20 @@ static const AVCodecDescriptor codec_descriptors[] = {
         .long_name = NULL_IF_CONFIG_SMALL("AVFrame to AVPacket passthrough"),
         .props     = AV_CODEC_PROP_LOSSLESS,
     },
+    {
+        .id        = AV_CODEC_ID_AUDIO_NULL,
+        .type      = AVMEDIA_TYPE_AUDIO,
+        .name      = "null_audio",
+        .long_name = NULL_IF_CONFIG_SMALL("Audio NULL"),
+        .props     = AV_CODEC_PROP_LOSSY,
+    },
+    {
+        .id        = AV_CODEC_ID_VIDEO_NULL,
+        .type      = AVMEDIA_TYPE_VIDEO,
+        .name      = "null_video",
+        .long_name = NULL_IF_CONFIG_SMALL("Video NULL"),
+        .props     = AV_CODEC_PROP_LOSSY,
+    },
 };
 
 static int descriptor_compare(const void *key, const void *member)
diff --git a/libavcodec/codec_id.h b/libavcodec/codec_id.h
index 3ffb9bd22e..4822dc7685 100644
--- a/libavcodec/codec_id.h
+++ b/libavcodec/codec_id.h
@@ -571,6 +571,8 @@ enum AVCodecID {
                                 * stream (only used by libavformat) */
     AV_CODEC_ID_FFMETADATA = 0x21000,   ///< Dummy codec for streams containing only metadata information.
     AV_CODEC_ID_WRAPPED_AVFRAME = 0x21001, ///< Passthrough codec, AVFrames wrapped in AVPacket
+    AV_CODEC_ID_AUDIO_NULL = 0x21002, ///< Null audio codec
+    AV_CODEC_ID_VIDEO_NULL = 0x21003, ///< Null video codec
 };
 
 /**
diff --git a/libavcodec/nullenc.c b/libavcodec/nullenc.c
new file mode 100644
index 0000000000..8d3553ed33
--- /dev/null
+++ b/libavcodec/nullenc.c
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2022 The FFmpeg Project
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "libavutil/internal.h"
+#include "libavutil/frame.h"
+#include "libavutil/buffer.h"
+
+#include "avcodec.h"
+#include "internal.h"
+#include "encode.h"
+
+static int null_encoder(AVCodecContext *avctx, AVPacket *pkt,
+                        const AVFrame *frame, int *got_packet)
+{
+    int ret;
+
+    pkt->pts = frame->pts;
+    if (avctx->codec_type == AVMEDIA_TYPE_AUDIO)
+        pkt->duration = ff_samples_to_time_base(avctx, frame->nb_samples);
+    pkt->flags |= AV_PKT_FLAG_KEY;
+    if ((ret = ff_alloc_packet(avctx, pkt, 1)) < 0)
+        return ret;
+    *got_packet = 1;
+    return 0;
+}
+
+const AVCodec ff_null_video_encoder = {
+    .name           = "null_video",
+    .long_name      = NULL_IF_CONFIG_SMALL("Video NULL encoder"),
+    .type           = AVMEDIA_TYPE_VIDEO,
+    .id             = AV_CODEC_ID_VIDEO_NULL,
+    .encode2        = null_encoder,
+    .caps_internal  = FF_CODEC_CAP_INIT_THREADSAFE,
+};
+
+const AVCodec ff_null_audio_encoder = {
+    .name           = "null_audio",
+    .long_name      = NULL_IF_CONFIG_SMALL("Audio NULL encoder"),
+    .type           = AVMEDIA_TYPE_AUDIO,
+    .id             = AV_CODEC_ID_AUDIO_NULL,
+    .encode2        = null_encoder,
+    .caps_internal  = FF_CODEC_CAP_INIT_THREADSAFE,
+    .capabilities   = AV_CODEC_CAP_VARIABLE_FRAME_SIZE,
+};