diff --git a/libavcodec/Makefile b/libavcodec/Makefile
index 050934101c..0457f6d0fd 100644
--- a/libavcodec/Makefile
+++ b/libavcodec/Makefile
@@ -1252,6 +1252,8 @@ SKIPHEADERS-$(CONFIG_V4L2_M2M)         += v4l2_buffers.h v4l2_context.h v4l2_m2m
 
 TESTPROGS = avcodec                                                     \
             avpacket                                                    \
+            bitstream_be                                                \
+            bitstream_le                                                \
             celp_math                                                   \
             codec_desc                                                  \
             htmlsubtitles                                               \
diff --git a/libavcodec/tests/bitstream_be.c b/libavcodec/tests/bitstream_be.c
new file mode 100644
index 0000000000..bc562ed3b1
--- /dev/null
+++ b/libavcodec/tests/bitstream_be.c
@@ -0,0 +1,19 @@
+/*
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "bitstream_template.c"
diff --git a/libavcodec/tests/bitstream_le.c b/libavcodec/tests/bitstream_le.c
new file mode 100644
index 0000000000..a907676438
--- /dev/null
+++ b/libavcodec/tests/bitstream_le.c
@@ -0,0 +1,20 @@
+/*
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#define BITSTREAM_READER_LE
+#include "bitstream_template.c"
diff --git a/libavcodec/tests/bitstream_template.c b/libavcodec/tests/bitstream_template.c
new file mode 100644
index 0000000000..8685f27b0c
--- /dev/null
+++ b/libavcodec/tests/bitstream_template.c
@@ -0,0 +1,153 @@
+/*
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#define ASSERT_LEVEL 2
+
+#include "libavutil/avassert.h"
+#include "libavutil/lfg.h"
+#include "libavutil/random_seed.h"
+
+#include "libavcodec/bitstream.h"
+#include "libavcodec/defs.h"
+
+#ifdef BITSTREAM_READER_LE
+#define BITSTREAM_WRITER_LE
+#endif
+#include "libavcodec/put_bits.h"
+
+#define SIZE 157
+
+enum Op {
+    OP_READ,
+    OP_READ_NZ,
+    OP_READ_BIT,
+    OP_READ_63,
+    OP_READ_64,
+    OP_READ_SIGNED,
+    OP_UNGET,
+    OP_NB,
+};
+
+int main(int argc, char **argv)
+{
+    BitstreamContext bc;
+    PutBitContext    pb;
+    AVLFG            lfg;
+
+    uint8_t buf[SIZE + AV_INPUT_BUFFER_PADDING_SIZE];
+    uint8_t dst[SIZE + AV_INPUT_BUFFER_PADDING_SIZE];
+
+    uint32_t random_seed;
+    uint64_t val;
+    int32_t  sval;
+    unsigned count;
+
+    /* generate random input, using a given or random seed */
+    if (argc > 1)
+        random_seed = strtoul(argv[1], NULL, 0);
+    else
+        random_seed = av_get_random_seed();
+
+    fprintf(stderr, "Testing with LFG seed: %"PRIu32"\n", random_seed);
+    av_lfg_init(&lfg, random_seed);
+
+    for (unsigned i = 0; i < SIZE; i++)
+        buf[i] = av_lfg_get(&lfg);
+
+    bits_init8   (&bc, buf, SIZE);
+    init_put_bits(&pb, dst, SIZE);
+
+    /* use a random sequence of bitreading operations to transfer data
+     * from BitstreamContext to PutBitContext */
+    while (bits_left(&bc) > 0) {
+        enum Op op = av_lfg_get(&lfg) % OP_NB;
+
+        switch (op) {
+        case OP_READ:
+            count = av_lfg_get(&lfg) % FFMIN(33, bits_left(&bc) + 1);
+            val   = bits_read(&bc, count);
+
+            fprintf(stderr, "%d read %u: %"PRIu64"\n", bits_tell(&bc) - count, count, val);
+
+            put_bits64(&pb, count, val);
+            break;
+        case OP_READ_NZ:
+            count = av_lfg_get(&lfg) % FFMIN(33, bits_left(&bc) + 1);
+            count = FFMAX(count, 1);
+            val   = bits_read_nz(&bc, count);
+
+            fprintf(stderr, "%d read_nz %u: %"PRIu64"\n", bits_tell(&bc) - count, count, val);
+
+            put_bits64(&pb, count, val);
+            break;
+        case OP_READ_BIT:
+            val = bits_read_bit(&bc);
+
+            fprintf(stderr, "%d read_bit: %"PRIu64"\n", bits_tell(&bc) - 1, val);
+
+            put_bits(&pb, 1, val);
+            break;
+        case OP_READ_63:
+            count = av_lfg_get(&lfg) % FFMIN(64, bits_left(&bc) + 1);
+            val   = bits_read_63(&bc, count);
+
+            fprintf(stderr, "%d read_63 %u: %"PRIu64"\n", bits_tell(&bc) - count, count, val);
+
+            put_bits64(&pb, count, val);
+            break;
+        case OP_READ_64:
+            count = av_lfg_get(&lfg) % FFMIN(65, bits_left(&bc) + 1);
+            val   = bits_read_64(&bc, count);
+
+            fprintf(stderr, "%d read_64 %u: %"PRIu64"\n", bits_tell(&bc) - count, count, val);
+
+            put_bits64(&pb, count, val);
+            break;
+        case OP_READ_SIGNED:
+            count = av_lfg_get(&lfg) % FFMIN(33, bits_left(&bc) + 1);
+            sval  = bits_read_signed(&bc, count);
+
+            fprintf(stderr, "%d read_signed %u: %"PRId32"\n", bits_tell(&bc) - count, count, sval);
+
+            if (count == 32) put_bits32(&pb, sval);
+            else             put_sbits(&pb, count, sval);
+            break;
+        case OP_UNGET:
+            count = av_lfg_get(&lfg) % FFMIN(33, bits_left(&bc) + 1);
+            val   = bits_read(&bc, count);
+            bits_unget(&bc, val, count);
+
+            fprintf(stderr, "%d unget %u: %"PRIu64"\n", bits_tell(&bc), count, val);
+
+            break;
+        default:
+            av_assert0(0);
+        }
+    }
+
+    flush_put_bits(&pb);
+
+    for (unsigned i = 0; i < SIZE; i++)
+        if (buf[i] != dst[i]) {
+            fprintf(stderr, "Mismatch at byte %u: %hhu %hhu; seed %"PRIu32"\n",
+                    i, buf[i], dst[i], random_seed);
+            return 1;
+        }
+
+    return 0;
+}
diff --git a/tests/fate/libavcodec.mak b/tests/fate/libavcodec.mak
index aa199e0308..8f56fae3a8 100644
--- a/tests/fate/libavcodec.mak
+++ b/tests/fate/libavcodec.mak
@@ -3,6 +3,16 @@ fate-avpacket: libavcodec/tests/avpacket$(EXESUF)
 fate-avpacket: CMD = run libavcodec/tests/avpacket$(EXESUF)
 fate-avpacket: CMP = null
 
+FATE_LIBAVCODEC-yes += fate-bitstream-be
+fate-bitstream-be: libavcodec/tests/bitstream_be$(EXESUF)
+fate-bitstream-be: CMD = run libavcodec/tests/bitstream_be$(EXESUF)
+fate-bitstream-be: CMP = null
+
+FATE_LIBAVCODEC-yes += fate-bitstream-le
+fate-bitstream-le: libavcodec/tests/bitstream_le$(EXESUF)
+fate-bitstream-le: CMD = run libavcodec/tests/bitstream_le$(EXESUF)
+fate-bitstream-le: CMP = null
+
 FATE_LIBAVCODEC-$(CONFIG_CABAC) += fate-cabac
 fate-cabac: libavcodec/tests/cabac$(EXESUF)
 fate-cabac: CMD = run libavcodec/tests/cabac$(EXESUF)